<?php

//todo: Need to update file name; it should be 'ReactionController'

namespace Drupal\reaction\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\Core\Database\Connection;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Drupal\Core\Ajax\AjaxResponse;
use Drupal\Core\Ajax\ChangedCommand;
use Drupal\Core\Ajax\CssCommand;
use Drupal\Core\Session\AccountInterface;
use Drupal\Core\Ajax\HtmlCommand;
use Drupal\Core\Ajax\InvokeCommand;
use Drupal\Core\Url;

//todo: remove unused imports

/**
 * Default controller for the ajax_link module.
 */
class DefaultController extends ControllerBase {

  // todo: comments doc required for class members & methods.
  protected $database;

  /**
   * @var AccountInterface $account
   */
  protected $account;

  public function __construct(Connection $database, AccountInterface $account) {
    $this->database = $database;
    $this->account = $account;
  }

  public static function create(ContainerInterface $container) {
    return new static(
        $container->get('database'), $container->get('current_user')
    );
  }

  public function ajax_link_response($url_encode_data) {
    global $base_url;
    //decode with str_pad since the url is appending with '=' to remove that
    //refer http://php.net/manual/en/function.base64-encode.php#103849
    $base64_decode = base64_decode(str_pad(strtr($url_encode_data, '-_', '+/'), strlen($url_encode_data) % 4, '=', STR_PAD_RIGHT));
    $decode_data = json_decode($base64_decode);
    //The decoded data in object
    $entity_type = $decode_data->entity_type;
    $bundle = $decode_data->bundle;
    $field_name = $decode_data->field_name;
    $entity_id = $decode_data->entity_id;
    $expression = $decode_data->expression;
    $token = $decode_data->token;
    $ip = $decode_data->ip;
    $count = $decode_data->reacted_count;
    $emoji_array = $decode_data->reaction_emoji_display;
    $style_setting = $decode_data->style_setting;
    $layout_style = $decode_data->layout_style;

    $module_path = drupal_get_path('module', 'reaction');
    $user_id = $this->account->id();
    $output = t("This is some content delivered via aAJAX" . $token);
    // See ajax_example_advanced.inc for more details on the available commands
    // and how to use them.
    // Get the private key.
    // todo: inject services.
    $private_key = \Drupal::service('private_key')->get();
    // Get a drupal CSRF token. (The actual service is called 'csrf_token').
    $token_generator = \Drupal::csrfToken();
    $token_validator = $token_generator->validate($token);
    // @todo : Token validation
    $a = 'fal';
    if ($token_validator) {
      $a = 'tru';
    }
    //$emoji_array = explode(",", $reaction_emoji_display);
    $uid = \Drupal::currentUser()->id();
    if($uid == 0) {
      $query = db_select('reaction_user_track', 'rut');
      $query->join('reaction', 'r', 'rut.rut_id = r.rut_id');
      $query->fields('r', array('eid'));
      $query->fields('rut', array('uid'));
      $query->condition('rut.ip_address', $ip);
      $query->condition('r.eid', $entity_id);
    }else{
      $query = db_select('reaction_user_track', 'rut');
      $query->join('reaction', 'r', 'rut.rut_id = r.rut_id');
      $query->fields('r', array('eid'));
      $query->fields('rut', array('uid'));
      $query->condition('rut.uid', $user_id);
      $query->condition('r.eid', $entity_id);
    }
    $result = $query->execute()->fetchAll();
    if (count($result) >= 1) {
      $reacted = TRUE;
    }
    //inserting only if its new data (i.e)avoid inserting through url directly
    else {
      $rut_id = $this->database->insert('reaction_user_track')
          ->fields(array('uid' => $user_id,
            'ip_address' => $ip,
            'other' => 'other'))
          ->execute();
      if ($rut_id) {
        $this->database->insert('reaction')
            ->fields(array('entity_type' => $entity_type,
              'bundle' => $bundle,
              'value' => $expression,
              'eid' => $entity_id,
              'rut_id' => $rut_id,
              'created' => REQUEST_TIME,))
            ->execute();
      }
      //after inserting setting reacted to true
      $reacted = TRUE;
    }
      $total_count=0;
    //To get the total count which we are using in calculate percentage
    foreach ($emoji_array as $emoji) {
      $count = _get_count_reaction($entity_id, $emoji);
      $total_count +=$count;
    }

    //formula used for calculate percentage
    // 100/Total count number of reacted result and multiplying the result 
    // with count of each emoji to get the percentage
    foreach ($emoji_array as $emoji) {
      $user_reacted_emoji_class = _get_reacted_emoji_class($entity_id, $emoji, $user_id);
      $count = _get_count_reaction($entity_id, $emoji);
      $percentage_calculate = 100 / $total_count;
      $image[] = array(
        'image_path' => $base_url . '/' . $module_path . '/vendor/krknth/reaction/' . $style_setting . '/' . $emoji . '.png',
        'reacted_count' => $count,
        'user_reacted_emoji' => $user_reacted_emoji_class,
        'percentage' => is_nan(round($count * $percentage_calculate)) ? 0 : round($count * $percentage_calculate),
        'emoji_name' => $emoji, 
      );
    }
    $elements[] = array(
      '#theme' => 'reaction_formatter',
      '#style' => $style_setting,
      '#image' => $image,
      '#layout_style' => $layout_style,
      '#reacted' => $reacted,
    );
    $ajax_response = new AjaxResponse();
    $value = $ajax_response->addCommand(new HtmlCommand('#reaction-wrapper', $elements));
    return $value;
  }

}
